function FontList()
{
 var fontlist=[
   "Sans-Serif",
   "Verdana",
   "Arial Unicode MS",
   "Arial",
   "Arial Black",
   "Arial Narrow",
   "Aharoni",
   "Book Antiqua",
   "Bookman Old Style",
   "Centaur",
   "Century Gothic",
   "Comic Sans MS",
   "Cooper Black",
   "Garamond",
   "Georgia",
   "Guttman Aharoni",
   "Guttman Calligraphic",
   "Guttman David",
   "Guttman Kav",
   "Guttman-Toledo",
   "Guttman Yad",
   "Guttman Yad-Brush",
   "Guttman Yad-Light",
   "Gill Sans Ultra Bold",
   "GillSans",
   "GillSans Condensed",
   "GillSans ExtraBold",
   "GillSans Light",
   "Goudy",
   "Goudy ExtraBold",
   "Haettenschweiler",
   "Helvetica",
   "Impact",
   "Lucida Console",
   "Lucida Sans",
   "Lucida Sans Unicode",
   "Microsoft Sans Serif",
   "Miriam",
   "Monotype Corsiva",
   "Narkisim",
   "Onyx",
   "Palatino Linotype",
   "Perpetua",
   "Rockwell",
   "Rockwell Condensed",
   "Serif",
   "Tahoma",
   "Times",
   "Times New Roman",
   "Trebuchet MS",
   "Univers",
   "Univers 45 Light",
   "Univers 47 CondensedLight",
   "Univers 55",
   "Univers 57 Condensed",
   "Univers Condensed",
   "Univers ExtendedPS"]

 return fontlist
}

/**
 * JavaScript code to detect available availability of a
 * particular font in a browser using JavaScript and CSS.
 *
 * Author : Lalit Patel
 * Website: http://www.lalit.org/lab/javascript-css-font-detect/
 * License: Apache Software License 2.0
 *          http://www.apache.org/licenses/LICENSE-2.0
 * Version: 0.15 (21 Sep 2009)
 *          Changed comparision font to default from sans-default-default,
 *          as in FF3.0 font of child element didn't fallback
 *          to parent element if the font is missing.
 * Version: 0.2 (04 Mar 2012)
 *          Comparing font against all the 3 generic font families ie,
 *          'monospace', 'sans-serif' and 'sans'. If it doesn't match all 3
 *          then that font is 100% not available in the system
 * Version: 0.3 (24 Mar 2012)
 *          Replaced sans with serif in the list of baseFonts
 */

/**
 * Usage: d = new Detector();
 *        d.detect('font name');
 */
var Detector = function() {
    // a font will be compared against all the three default fonts.
    // and if it doesn't match all 3 then that font is not available.
    var baseFonts = ['monospace', 'sans-serif', 'serif'];

    //we use m or w because these two characters take up the maximum width.
    // And we use a LLi so that the same matching fonts can get separated
    var testString = "mmmmmmmmmmlli";

    //we test using 72px font size, we may use any size. I guess larger the better.
    var testSize = '72px';

    var h = document.getElementsByTagName("body")[0];

 // create a SPAN in the document to get the width of the text we use to test
    var s = document.createElement("span");
    s.style.fontSize = testSize;
    s.innerHTML = testString;
    var defaultWidth = {};
    var defaultHeight = {};
    for (var index in baseFonts) {
      //get the default width for the three base fonts
      s.style.fontFamily = baseFonts[index];
      h.appendChild(s);
      defaultWidth[baseFonts[index]] = s.offsetWidth; //width for the default font
      defaultHeight[baseFonts[index]] = s.offsetHeight; //height for the defualt font
      h.removeChild(s);
    }

function detect(font) {
   var detected = false;
   for (var index in baseFonts) {
    s.style.fontFamily = font + ',' + baseFonts[index]; // name of the font along with the base font for fallback.
    h.appendChild(s);
    var matched = (s.offsetWidth != defaultWidth[baseFonts[index]] || s.offsetHeight != defaultHeight[baseFonts[index]]);
    h.removeChild(s);
    detected = detected || matched;
   }
   return detected;
}

    this.detect = detect;
}

function FontSelector()
{
 var i;
 var flist=FontList();
 //alert("flistl="+flist.length)
 var d= new Detector();
 var flistr = new Array ;
 var k=0;
 for ( i=0 ; i < flist.length ; i++ )
 { 
  var a=d.detect(flist[i])
  //alert("i="+i+" flisti="+flist[i]+"a="+a  )
  if ( a )
  {
   flistr[k]=flist[i];
   k=k+1
  }
 }
 return flistr
}

